Issue 124896 - remove obsoleted module-internal custom allocator in SAL
Summary: remove obsoleted module-internal custom allocator in SAL
Status: CLOSED FIXED
Alias: None
Product: General
Classification: Code
Component: code (show other issues)
Version: 4.1.0
Hardware: All All
: P3 Normal (vote)
Target Milestone: 4.1.1
Assignee: hdu@apache.org
QA Contact:
URL:
Keywords:
Depends on: 122362
Blocks: 124908
  Show dependency tree
 
Reported: 2014-05-14 13:53 UTC by hdu@apache.org
Modified: 2017-05-20 10:35 UTC (History)
4 users (show)

See Also:
Issue Type: TASK
Latest Confirmation in: ---
Developer Difficulty: ---
jsc: 4.1.1_release_blocker+


Attachments

Note You need to log in before you can comment on or make changes to this issue.
Description hdu@apache.org 2014-05-14 13:53:06 UTC
The SAL module avoided the heavy dependency on the stlport4-libraries by using a custom allocator for its internal STL containers. With issue 122362 stlport4 and these dependencies are gone, so the SAL-internal custom allocator is obsoleted.
Comment 1 hdu@apache.org 2014-05-14 14:41:23 UTC
Since the obsolete allocator also results in tricky build problems (e.g. attachment 82857 [details]) the removal solves these troubles too.
Comment 2 SVN Robot 2014-05-15 09:59:28 UTC
"hdu" committed SVN revision 1594842 into trunk:
#i124896# remove obsoleted sal-module-internal custom STL allocator
Comment 3 Steve Yin 2014-05-16 08:37:31 UTC
Hi Herbert. I got a build error on Windows which shows:

build -- version: 275224


=============
Building module sal
=============

Entering /cygdrive/d/Apache/trunk/openoffice/main/sal/inc


Entering /cygdrive/d/Apache/trunk/openoffice/main/sal/osl/w32

dmake:  Error: -- `../../inc/rtl/allocator.hxx' not found, and can't be made
ERROR: error 65280 occurred while making /cygdrive/d/Apache/trunk/openoffice/main/sal/osl/w32
Comment 4 hdu@apache.org 2014-05-16 09:21:26 UTC
(In reply to Steve Yin from comment #3)
> dmake:  Error: -- `../../inc/rtl/allocator.hxx' not found, and can't be made

This looks like a bad dependency in you build. The file allocator.hxx is not used anymore, so dmake can only know about this header by a former dependency analysis. Please run
   fgrep allocator.hxx main/sal
to confirm this. Then remove sal's output directory or better make a clean build.

FWIW issue 124903 mentioned a similar problem with obsoleted dependencies. Have there been any changes to the build system that would impact the dependency analysis?
Comment 5 hdu@apache.org 2014-05-16 11:01:04 UTC
self-reminder: With all AOO internal users of rtl/allocator gone and no known external users of it, there is no more need for allocator.hxx. Since it used to be shipped in the SDK we'll have to note this in the release notes. Or to reintroduce the obsolete file just to ship it with the SDK.
Comment 6 Steve Yin 2014-05-16 15:39:59 UTC
Hi Herbert. I tried to make a clean build by your suggestion. And some other build errors occurred.

D:/Apache/openoffice/main/sal/osl/w32/module.cxx(77) : error C2039: 'Allocator' : is not a member of 'rtl'
D:/Apache/openoffice/main/sal/osl/w32/module.cxx(77) : error C2065: 'Allocator' : undeclared identifier
D:/Apache/openoffice/main/sal/osl/w32/module.cxx(77) : error C2275: 'WCHAR' : illegal use of this type as an expression
        D:/Apache/BuildTools/MSSDK_v6.1/include\winnt.h(337) : see declaration of 'WCHAR'
D:/Apache/openoffice/main/sal/osl/w32/module.cxx(77) : error C2143: syntax error : missing ';' before '>'
D:/Apache/openoffice/main/sal/osl/w32/module.cxx(77) : error C2143: syntax error : missing ';' before '>'
D:/Apache/openoffice/main/sal/osl/w32/module.cxx(79) : error C2065: 'vec' : undeclared identifier
D:/Apache/openoffice/main/sal/osl/w32/module.cxx(82) : error C2065: 'vec' : undeclared identifier
D:/Apache/openoffice/main/sal/osl/w32/module.cxx(85) : error C2065: 'vec' : undeclared identifier
dmake:  Error code 2, while making '../../wntmsci12.pro/obj/module.obj'
ERROR: error 65280 occurred while making /cygdrive/d/Apache/openoffice/main/sal/osl/w32
Comment 7 SVN Robot 2014-05-16 20:11:37 UTC
"hdu" committed SVN revision 1595333 into trunk:
#i124896# use default allocator for w32 ShortPathName buffer
Comment 8 SVN Robot 2014-05-17 02:40:23 UTC
"steve_y" committed SVN revision 1595419 into trunk:
i124896 add including of rtl/alloc.h in path_helper.hxx for win32
Comment 9 hdu@apache.org 2014-05-22 13:10:27 UTC
Fixed with the commits above. Thanks Steve.
Comment 10 jsc 2014-06-12 14:48:57 UTC
grant showstopper flag for AOO 4.1.1

changes are necessary to build the branch on 10.9.x and Xcode 5.1
Comment 11 SVN Robot 2014-06-12 14:56:18 UTC
"jsc" committed SVN revision 1602187 into branches/AOO410:
#124896# merge changes from trunk to be able to build on macos 10.9.3 and Xco...
Comment 12 fanyuzhen 2014-07-07 07:32:08 UTC
It's verified fixed on Windows via build level testing
Comment 13 Kay 2014-07-08 02:06:24 UTC
Verified fixed on r1608485, Linux-32. Builds OK.
Comment 14 Steve Yin 2014-07-23 07:14:21 UTC
Verified on r1611634, Mac OS 10.7.5